# Copyright 2017 Sandvine
#
# All Rights Reserved.
#
#    Licensed under the Apache License, Version 2.0 (the "License"); you may
#    not use this file except in compliance with the License. You may obtain
#    a copy of the License at
#
#         http://www.apache.org/licenses/LICENSE-2.0
#
#    Unless required by applicable law or agreed to in writing, software
#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
#    License for the specific language governing permissions and limitations
#    under the License.

import time


def wait_for_value(func, result=True, wait_time=10, catch_exception=None):
    maxtime = time.time() + wait_time
    while time.time() < maxtime:
        try:
            if func() == result:
                return True
        except catch_exception:
            pass
        time.sleep(1)
    try:
        return func() == result
    except catch_exception:
        return False
